import es
import random
import gamethread

info = es.AddonInfo() 
info.name     = "UNO" 
info.version  = "2.0.0" 
info.url      = "http://addons.eventscripts.com/addons/view/uno" 
info.basename = "UNO" 
info.author   = "DHack" 
es.ServerVar('UNO_Ver', info.version, 'UNO Version').makepublic()


cards = ['R0', 'R1', 'R2', 'R3', 'R4', 'R5', 'R6', 'R7', 'R8', 'R9',
               'R1', 'R2', 'R3', 'R4', 'R5', 'R6', 'R7', 'R8', 'R9',
               'RD2', 'RD2', 'RS', 'RS', 'RR', 'RR',
         'B0', 'B1', 'B2', 'B3', 'B4', 'B5', 'B6', 'B7', 'B8', 'B9',
               'B1', 'B2', 'B3', 'B4', 'B5', 'B6', 'B7', 'B8', 'B9',
               'BD2', 'BD2', 'BS', 'BS', 'BR', 'BR',
         'Y0', 'Y1', 'Y2', 'Y3', 'Y4', 'Y5', 'Y6', 'Y7', 'Y8', 'Y9',
               'Y1', 'Y2', 'Y3', 'Y4', 'Y5', 'Y6', 'Y7', 'Y8', 'Y9',
               'YD2', 'YD2', 'YS', 'YS', 'YR', 'YR',
         'G0', 'G1', 'G2', 'G3', 'G4', 'G5', 'G6', 'G7', 'G8', 'G9',
               'G1', 'G2', 'G3', 'G4', 'G5', 'G6', 'G7', 'G8', 'G9',
               'GD2', 'GD2', 'GS', 'GS', 'GR', 'GR',
         'WD4', 'WD4', 'WD4', 'WD4', 'W', 'W', 'W', 'W']
d2 = ['RD2', 'BD2', 'YD2', 'GD2']
d4 = ['RD4', 'BD4', 'YD4', 'GD4', 'D4R', 'D4B', 'D4Y', 'D4G']
wilds = ['RW', 'BW', 'GW', 'YW', 'WR', 'WB', 'WG', 'WY']
reverses = ['RR', 'YR', 'GR', 'BR']
skips = ['RS', 'YS', 'GS', 'BS']

gameon = 'False'
unoplayers = {}
turns = []
topcard = 'none'

def load():
    es.regsaycmd('!join', 'uno/join', 'Join the uno game')
    es.regsaycmd('!joinuno', 'uno/join', 'Join the uno game')
    es.regsaycmd('!hand', 'uno/hand', 'Tells you your uno hand')
    es.regsaycmd('!showhand', 'uno/hand', 'Tells you your uno hand')
    es.regsaycmd('!play', 'uno/play', 'Play A Card, or draw')
    es.regsaycmd('!turn', 'uno/turn', 'Tells the order of turns')
    es.regsaycmd('!tc', 'uno/tc', 'Tells the order of turns')
    es.regsaycmd('!topcard', 'uno/tc', 'Tells the order of turns')
    es.regsaycmd('!uno', 'uno/commands', 'Tells uno commands')
    es.regsaycmd('!leave', 'uno/leave', 'Lets you leave the uno game')
    es.regsaycmd('!leavegame', 'uno/leave', 'Lets you leave the uno game')
    es.regsaycmd('!players', 'uno/players', 'Lets you leave the uno game')

def commands():
    userid = es.getcmduserid()

def player_disconnect(ev):
    if int(ev['userid']) in turns:
       leave(ev['userid']) 

def players():
    userid = es.getcmduserid()
    tell(userid, turns)

def leave(userid = 'none'):
    if userid == 'none':
        userid = es.getcmduserid()
    if turns[0] and userid == turns[0]:
        lastplayer = turns[0]
        del turns[0]
        tell(userid, 'You have left the UNO game!')
        if turns:
            for users in turns:
                tell(users, '#lightgreen%s #defaultHas left the game.' % es.getplayername(lastplayer))
        if len(turns) > 1:
            next(topcard)
        else:
            gameend(turns[0])
        return
    del turns[turns.index(int(userid))]
    if len(turns) > 1:
        next(topcard)
    else:
        gameend(turns[0])

def tc():
    tell(es.getcmduserid(), 'Top card is #lightgreen%s' % topcard)

def turn():
    if turns:
        userid = es.getcmduserid()
        tell(userid, "It's " + str(es.getplayername(turns[0])) + " Turn")

def join():
    userid = es.getcmduserid()
    if not userid in turns and len(turns) < 7:
        turns.append(userid)
        tell(userid, 'You are now playing uno')
        if gameon == 'True':
            deal(userid)
            tell(userid, 'You are now playing UNO. Wait your turn.')
        elif len(unoplayers) == 1:
            tell(userid, 'You must wait till another person joins you')
        elif gameon == 'False' and len(turns) == 2:
            startgame()
        elif gameon == 'intermission':
            tell(userid, 'You are now in the game. Please wait for the intermission to be over.')
    else:
        tell(userid, 'Sorry game is full')

def deal(userid):
    if not userid in unoplayers:
        unoplayers[userid] = []
        x = 0
        while x < 7:
            x += 1
            unoplayers[userid].append(cards[0])
            del cards[0]

def play():
    userid = es.getcmduserid()
    command = str(es.getargv(1)).lower()
    top = topcard
    if topcard in d2:
         top = topcard.replace('2','')
    if topcard == 'RED':
        top = 'R'
    if topcard == 'BLUE':
        top = 'B'
    if topcard == 'YELLOW':
        top = 'Y'
    if topcard == 'GREEN':
        top = 'G'
    if turns and userid == turns[0]:
        if command.upper() in reverses and topcard in reverses:
            reverse(command.upper(), userid)
        if command.upper() in wilds and 'W' in unoplayers[userid]:
            next(command.upper(),userid)
            return
        if command.upper() in d4 and 'WD4' in unoplayers[userid]:
            draw4(command.upper(), userid)
            return
        if command.upper() in unoplayers[userid]:
            if command.upper() in d2 and topcard in d2:
                draw2(command.upper(), userid)
                return
            for letter in top:
                if letter.lower() in command:
                    if command.upper() in skips:
                        skip(command.upper(), userid)
                        return
                    if command.upper() in reverses:
                        reverse(command.upper(), userid)
                        return
                    if command.upper() in d2:
                        draw2(command.upper(), userid)
                        return
                    next(command.upper(), userid)
                    return
            tell(userid, 'You cant play a #lightgreen%s' % es.getargv(1))
        if command == 'draw':
            newcard = cards[0]
            del cards[0]
            unoplayers[userid].append(newcard)
            tell(userid, 'You drew a #lightgreen%s' % newcard)
            next(topcard)
        else:
            tell(userid, 'You do not have a #lightgreen%s' % es.getargv(1))
            
    else:
        tell(userid, 'It is not your turn')

def draw4(card, lastplayer):
    card1 = cards[0]
    del cards[0]
    card2 = cards[0]
    del cards[0]
    card3 = cards[0]
    del cards[0]
    card4 = cards[0]
    del cards[0]
    unoplayers[turns[1]].append(card1)
    unoplayers[turns[1]].append(card2)
    unoplayers[turns[1]].append(card3)
    unoplayers[turns[1]].append(card4)
    tell(turns[1], 'You had to draw4 #lightgreen(%s, %s, %s, %s) #defaultand you were skipped' %(card1,card2,card3,card4))
    lastplayer = turns[0]
    del turns[0]
    turns.append(lastplayer)
    next(card, lastplayer)

def reverse(card, lastplayer):
    global topcard
    del unoplayers[lastplayer][unoplayers[lastplayer].index(lastcard)]
    turns.reverse()
    for player in turns:
        if not lastplayer == player:
            tell(player, 'Player #lightgreen%s #defaulthas played a #lightgreen%s'%(es.getplayername(lastplayer),card))
        else:
            tell(player, 'You have played A #lightgreen%s' % card)
        if check(lastplayer) == 0:
            gameend(lastplayer)
            return
    card = card.replace('R', '')
    if card == '':
        card = 'RED'
    if card == 'B':
        card = 'BLUE'
    if card == 'Y':
        card = 'YELLOW'
    if card == 'G':
        card = 'GREEN'
    topcard = card
    tell(turns[0], 'Its now your turn topcard is #lightgreen%s' % topcard)
    hand(turns[0])

def skip(card, lastplayer):
    lastplayer = turns[0]
    del turns[0]
    turns.append(lastplayer)
    tell(turns[1], 'You were skiped')
    next(card, lastplayer)

def draw2(card, lastplayer):
    card1 = cards[0]
    del cards[0]
    card2 = cards[0]
    del cards[0]
    unoplayers[turns[1]].append(card1)
    unoplayers[turns[1]].append(card2)
    tell(turns[1], 'You had to draw2 #lightgreen(%s, %s) #defaultand you were skipped' %(card1,card2))
    lastplayer = turns[0]
    del turns[0]
    turns.append(lastplayer)
    next(card, lastplayer)

def next(card, lastplayer = 'none'):
    global topcard
    if not lastplayer == 'none':
        for player in turns:
            if not lastplayer == player:
                tell(player, 'Player #lightgreen%s #defaulthas played a #lightgreen%s'%(es.getplayername(lastplayer),card))
            else:
                tell(player, 'You have played A #lightgreen%s' % card)
        if check(lastplayer) == 0:
            gameend(lastplayer)
            return
        if card in wilds:
            del unoplayers[lastplayer][unoplayers[lastplayer].index('W')]
        if card in d4:
            del unoplayers[lastplayer][unoplayers[lastplayer].index('WD4')]
        if card in unoplayers[lastplayer]:
            del unoplayers[lastplayer][unoplayers[lastplayer].index(card)]
    if card in wilds:
        card = card.replace('W', '')
    if card in d4:
        card = card.replace('D4', '')
    if card == 'R':
        card = 'RED'
    if card == 'B':
        card = 'BLUE'
    if card == 'Y':
        card = 'YELLOW'
    if card == 'G':
        card = 'GREEN'
    topcard = card
    lastplayer = turns[0]
    del turns[0]
    turns.append(lastplayer)
    tell(turns[0], 'Its now your turn topcard is #lightgreen%s' % topcard)
    hand(turns[0])

def startgame():
    global topcard, gameon
    random.shuffle(cards)
    gameon = 'True'
    for userid in turns:
        deal(userid)
    for userid in turns:
        tell(userid, 'Game Has Now Started')
    topcard = cards[0]
    del cards[0]
    next(topcard)

def check(userid):
    if userid in turns:
        return len(unoplayers[userid])

def tell(userid ,text):
    es.tell(userid, "#multi", "#green[UNO Dealer] #lightgreen%s #default%s."%(es.getplayername(userid),text))

def hand(userid = 'none'):
    if userid == 'none':
        userid = es.getcmduserid()
    if userid in turns:
        tell(userid, 'Your hand is: %s'%unoplayers[userid])

def gameend(winner):
    global unoplayers
    global turns
    global topcard
    global gameon
    global cards
    cards = ['R0', 'R1', 'R2', 'R3', 'R4', 'R5', 'R6', 'R7', 'R8', 'R9',
               'R1', 'R2', 'R3', 'R4', 'R5', 'R6', 'R7', 'R8', 'R9',
               'RD2', 'RD2', 'RS', 'RS', 'RR', 'RR',
         'B0', 'B1', 'B2', 'B3', 'B4', 'B5', 'B6', 'B7', 'B8', 'B9',
               'B1', 'B2', 'B3', 'B4', 'B5', 'B6', 'B7', 'B8', 'B9',
               'BD2', 'BD2', 'BS', 'BS', 'BR', 'BR',
         'Y0', 'Y1', 'Y2', 'Y3', 'Y4', 'Y5', 'Y6', 'Y7', 'Y8', 'Y9',
               'Y1', 'Y2', 'Y3', 'Y4', 'Y5', 'Y6', 'Y7', 'Y8', 'Y9',
               'YD2', 'YD2', 'YS', 'YS', 'YR', 'YR',
         'G0', 'G1', 'G2', 'G3', 'G4', 'G5', 'G6', 'G7', 'G8', 'G9',
               'G1', 'G2', 'G3', 'G4', 'G5', 'G6', 'G7', 'G8', 'G9',
               'GD2', 'GD2', 'GS', 'GS', 'GR', 'GR',
         'WD4', 'WD4', 'WD4', 'WD4', 'W', 'W', 'W', 'W']
    unoplayers = {}
    turns = []
    topcard = 'none'
    gameon = 'intermission'
    if winner != 'none':
        es.msg("#multi", "#green[UNO Dealer] #defaultA game of UNO has just been won by #lightgreen%s." % es.getplayername(winner))
    else:
        es.msg("#multi", "#green[UNO Dealer] #defaultA game of UNO has just been won by #lightgreenNo onE.")
    es.msg("#multi", "#green[UNO Dealer] #defaultA new game will now start after a 60 sec intermission, type !join to play.")
    gamethread.delayed(60, endintermission) 

def endintermission():
    global gameon
    if len(unoplayers) > 1:
        gameon = 'True'
        startgame()
    else:
        gameon = 'False'